--- old/usr/src/uts/common/os/watchpoint.c	2015-11-06 21:07:26.633186392 -0500
+++ new/usr/src/uts/common/os/watchpoint.c	2015-11-06 21:07:26.636747158 -0500
@@ -24,8 +24,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sys/types.h>
 #include <sys/t_lock.h>
 #include <sys/param.h>
@@ -182,11 +180,7 @@
 	/*
 	 * as->a_wpage can only be changed while the process is totally stopped.
 	 * Don't grab p_lock here.  Holding p_lock while grabbing the address
-	 * space lock leads to deadlocks with the clock thread.  Note that if an
-	 * as_fault() is servicing a fault to a watched page on behalf of an
-	 * XHAT provider, watchpoint will be temporarily cleared (and wp_prot
-	 * will be set to wp_oprot).  Since this is done while holding as writer
-	 * lock, we need to grab as lock (reader lock is good enough).
+	 * space lock leads to deadlocks with the clock thread.
 	 *
 	 * p_maplock prevents simultaneous execution of this function.  Under
 	 * normal circumstances, holdwatch() will stop all other threads, so the
@@ -196,7 +190,6 @@
 	 */
 
 	mutex_enter(&p->p_maplock);
-	AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
 
 	tpw.wp_vaddr = (caddr_t)((uintptr_t)addr & (uintptr_t)PAGEMASK);
 	if ((pwp = avl_find(&as->a_wpage, &tpw, &where)) == NULL)
@@ -231,11 +224,6 @@
 			 * all other lwps are held in the kernel.
 			 */
 			if (p->p_mapcnt == 0) {
-				/*
-				 * Release as lock while in holdwatch()
-				 * in case other threads need to grab it.
-				 */
-				AS_LOCK_EXIT(as, &as->a_lock);
 				mutex_exit(&p->p_maplock);
 				if (holdwatch() != 0) {
 					/*
@@ -246,7 +234,6 @@
 					goto startover;
 				}
 				mutex_enter(&p->p_maplock);
-				AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
 			}
 			p->p_mapcnt++;
 		}
@@ -306,7 +293,6 @@
 			uint_t oprot;
 			int err, retrycnt = 0;
 
-			AS_LOCK_EXIT(as, &as->a_lock);
 			AS_LOCK_ENTER(as, &as->a_lock, RW_WRITER);
 		retry:
 			seg = as_segat(as, addr);
@@ -321,8 +307,7 @@
 				}
 			}
 			AS_LOCK_EXIT(as, &as->a_lock);
-		} else
-			AS_LOCK_EXIT(as, &as->a_lock);
+		}
 
 		/*
 		 * When all pages are mapped back to their normal state,
@@ -339,11 +324,8 @@
 				mutex_enter(&p->p_maplock);
 			}
 		}
-
-		AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
 	}
 
-	AS_LOCK_EXIT(as, &as->a_lock);
 	mutex_exit(&p->p_maplock);
 
 	return (rv);
@@ -436,7 +418,6 @@
 
 
 
-/* Must be called with as lock held */
 int
 pr_is_watchpage_as(caddr_t addr, enum seg_rw rw, struct as *as)
 {
@@ -499,17 +480,11 @@
 pr_is_watchpage(caddr_t addr, enum seg_rw rw)
 {
 	struct as *as = curproc->p_as;
-	int rv;
 
 	if ((as == &kas) || avl_numnodes(&as->a_wpage) == 0)
 		return (0);
 
-	/* Grab the lock because of XHAT (see comment in pr_mappage()) */
-	AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
-	rv = pr_is_watchpage_as(addr, rw, as);
-	AS_LOCK_EXIT(as, &as->a_lock);
-
-	return (rv);
+	return (pr_is_watchpage_as(addr, rw, as));
 }
 
 
